diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/pxa3xx.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/pxa3xx.c
--- linux-3.0/arch/arm/mach-pxa/pxa3xx.c	2011-08-29 03:03:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/pxa3xx.c	2011-10-18 04:06:23.000000000 +0000
@@ -24,6 +24,7 @@
 #include <linux/i2c/pxa-i2c.h>
 
 #include <asm/mach/map.h>
+#include <asm/suspend.h>
 #include <mach/hardware.h>
 #include <mach/gpio.h>
 #include <mach/pxa3xx-regs.h>
@@ -31,7 +32,6 @@
 #include <mach/ohci.h>
 #include <mach/pm.h>
 #include <mach/dma.h>
-#include <mach/regs-intc.h>
 #include <mach/smemc.h>
 
 #include "generic.h"
@@ -141,8 +141,13 @@ static void pxa3xx_cpu_pm_suspend(void)
 {
 	volatile unsigned long *p = (volatile void *)0xc0000000;
 	unsigned long saved_data = *p;
+#ifndef CONFIG_IWMMXT
+	u64 acc0;
 
-	extern void pxa3xx_cpu_suspend(long);
+	asm volatile("mra %Q0, %R0, acc0" : "=r" (acc0));
+#endif
+
+	extern int pxa3xx_finish_suspend(unsigned long);
 
 	/* resuming from D2 requires the HSIO2/BOOT/TPM clocks enabled */
 	CKENA |= (1 << CKEN_BOOT) | (1 << CKEN_TPM);
@@ -162,11 +167,15 @@ static void pxa3xx_cpu_pm_suspend(void)
 	/* overwrite with the resume address */
 	*p = virt_to_phys(cpu_resume);
 
-	pxa3xx_cpu_suspend(PLAT_PHYS_OFFSET - PAGE_OFFSET);
+	cpu_suspend(0, pxa3xx_finish_suspend);
 
 	*p = saved_data;
 
 	AD3ER = 0;
+
+#ifndef CONFIG_IWMMXT
+	asm volatile("mar acc0, %Q0, %R0" : "=r" (acc0));
+#endif
 }
 
 static void pxa3xx_cpu_pm_enter(suspend_state_t state)
@@ -328,13 +337,13 @@ static void pxa_ack_ext_wakeup(struct ir
 
 static void pxa_mask_ext_wakeup(struct irq_data *d)
 {
-	ICMR2 &= ~(1 << ((d->irq - PXA_IRQ(0)) & 0x1f));
+	pxa_mask_irq(d);
 	PECR &= ~PECR_IE(d->irq - IRQ_WAKEUP0);
 }
 
 static void pxa_unmask_ext_wakeup(struct irq_data *d)
 {
-	ICMR2 |= 1 << ((d->irq - PXA_IRQ(0)) & 0x1f);
+	pxa_unmask_irq(d);
 	PECR |= PECR_IE(d->irq - IRQ_WAKEUP0);
 }
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/pxa95x.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/pxa95x.c
--- linux-3.0/arch/arm/mach-pxa/pxa95x.c	2011-08-29 03:03:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/pxa95x.c	2011-10-18 04:06:23.000000000 +0000
@@ -27,7 +27,6 @@
 #include <mach/reset.h>
 #include <mach/pm.h>
 #include <mach/dma.h>
-#include <mach/regs-intc.h>
 
 #include "generic.h"
 #include "devices.h"
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/raumfeld.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/raumfeld.c
--- linux-3.0/arch/arm/mach-pxa/raumfeld.c	2011-08-29 03:03:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/raumfeld.c	2011-10-18 04:06:23.000000000 +0000
@@ -46,10 +46,7 @@
 #include <asm/mach-types.h>
 #include <asm/mach/arch.h>
 
-#include <mach/hardware.h>
-#include <mach/pxa3xx-regs.h>
-#include <mach/mfp-pxa3xx.h>
-#include <mach/mfp-pxa300.h>
+#include <mach/pxa300.h>
 #include <mach/ohci.h>
 #include <mach/pxafb.h>
 #include <mach/mmc.h>
@@ -1093,6 +1090,7 @@ MACHINE_START(RAUMFELD_RC, "Raumfeld Con
 	.init_machine	= raumfeld_controller_init,
 	.map_io		= pxa3xx_map_io,
 	.init_irq	= pxa3xx_init_irq,
+	.handle_irq	= pxa3xx_handle_irq,
 	.timer		= &pxa_timer,
 MACHINE_END
 #endif
@@ -1103,6 +1101,7 @@ MACHINE_START(RAUMFELD_CONNECTOR, "Raumf
 	.init_machine	= raumfeld_connector_init,
 	.map_io		= pxa3xx_map_io,
 	.init_irq	= pxa3xx_init_irq,
+	.handle_irq	= pxa3xx_handle_irq,
 	.timer		= &pxa_timer,
 MACHINE_END
 #endif
@@ -1113,6 +1112,7 @@ MACHINE_START(RAUMFELD_SPEAKER, "Raumfel
 	.init_machine	= raumfeld_speaker_init,
 	.map_io		= pxa3xx_map_io,
 	.init_irq	= pxa3xx_init_irq,
+	.handle_irq	= pxa3xx_handle_irq,
 	.timer		= &pxa_timer,
 MACHINE_END
 #endif
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/saar.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/saar.c
--- linux-3.0/arch/arm/mach-pxa/saar.c	2011-06-22 15:07:27.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/saar.c	2011-10-18 04:06:23.000000000 +0000
@@ -599,6 +599,7 @@ MACHINE_START(SAAR, "PXA930 Handheld Pla
 	.boot_params    = 0xa0000100,
 	.map_io         = pxa3xx_map_io,
 	.init_irq       = pxa3xx_init_irq,
+	.handle_irq       = pxa3xx_handle_irq,
 	.timer          = &pxa_timer,
 	.init_machine   = saar_init,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/saarb.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/saarb.c
--- linux-3.0/arch/arm/mach-pxa/saarb.c	2011-06-22 15:07:27.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/saarb.c	2011-10-18 04:06:23.000000000 +0000
@@ -104,9 +104,10 @@ static void __init saarb_init(void)
 
 MACHINE_START(SAARB, "PXA955 Handheld Platform (aka SAARB)")
 	.boot_params    = 0xa0000100,
-	.map_io         = pxa_map_io,
+	.map_io         = pxa3xx_map_io,
 	.nr_irqs	= SAARB_NR_IRQS,
 	.init_irq       = pxa95x_init_irq,
+	.handle_irq	= pxa3xx_handle_irq,
 	.timer          = &pxa_timer,
 	.init_machine   = saarb_init,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/sleep.S torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/sleep.S
--- linux-3.0/arch/arm/mach-pxa/sleep.S	2011-06-22 15:07:27.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/sleep.S	2011-10-18 04:06:23.000000000 +0000
@@ -24,20 +24,9 @@
 
 #ifdef CONFIG_PXA3xx
 /*
- * pxa3xx_cpu_suspend() - forces CPU into sleep state (S2D3C4)
- *
- * r0 = v:p offset
+ * pxa3xx_finish_suspend() - forces CPU into sleep state (S2D3C4)
  */
-ENTRY(pxa3xx_cpu_suspend)
-
-#ifndef CONFIG_IWMMXT
-	mra	r2, r3, acc0
-#endif
-	stmfd	sp!, {r2 - r12, lr}	@ save registers on stack
-	mov	r1, r0
-	ldr	r3, =pxa_cpu_resume	@ resume function
-	bl	cpu_suspend
-
+ENTRY(pxa3xx_finish_suspend)
 	mov	r0, #0x06		@ S2D3C4 mode
 	mcr	p14, 0, r0, c7, c0, 0	@ enter sleep
 
@@ -46,28 +35,18 @@ ENTRY(pxa3xx_cpu_suspend)
 
 #ifdef CONFIG_PXA27x
 /*
- * pxa27x_cpu_suspend()
+ * pxa27x_finish_suspend()
  *
  * Forces CPU into sleep state.
  *
  * r0 = value for PWRMODE M field for desired sleep state
- * r1 = v:p offset
  */
-ENTRY(pxa27x_cpu_suspend)
-
-#ifndef CONFIG_IWMMXT
-	mra	r2, r3, acc0
-#endif
-	stmfd	sp!, {r2 - r12, lr}		@ save registers on stack
-	mov	r4, r0				@ save sleep mode
-	ldr	r3, =pxa_cpu_resume		@ resume function
-	bl	cpu_suspend
-
+ENTRY(pxa27x_finish_suspend)
 	@ Put the processor to sleep
 	@ (also workaround for sighting 28071)
 
 	@ prepare value for sleep mode
-	mov	r1, r4				@ sleep mode
+	mov	r1, r0				@ sleep mode
 
 	@ prepare pointer to physical address 0 (virtual mapping in generic.c)
 	mov	r2, #UNCACHED_PHYS_0
@@ -99,21 +78,16 @@ ENTRY(pxa27x_cpu_suspend)
 
 #ifdef CONFIG_PXA25x
 /*
- * pxa25x_cpu_suspend()
+ * pxa25x_finish_suspend()
  *
  * Forces CPU into sleep state.
  *
  * r0 = value for PWRMODE M field for desired sleep state
- * r1 = v:p offset
  */
 
-ENTRY(pxa25x_cpu_suspend)
-	stmfd	sp!, {r2 - r12, lr}		@ save registers on stack
-	mov	r4, r0				@ save sleep mode
-	ldr	r3, =pxa_cpu_resume		@ resume function
-	bl	cpu_suspend
+ENTRY(pxa25x_finish_suspend)
 	@ prepare value for sleep mode
-	mov	r1, r4				@ sleep mode
+	mov	r1, r0				@ sleep mode
 
 	@ prepare pointer to physical address 0 (virtual mapping in generic.c)
 	mov	r2, #UNCACHED_PHYS_0
@@ -195,16 +169,3 @@ pxa_cpu_do_suspend:
 	mcr	p14, 0, r1, c7, c0, 0		@ PWRMODE
 
 20:	b	20b				@ loop waiting for sleep
-
-/*
- * pxa_cpu_resume()
- *
- * entry point from bootloader into kernel during resume
- */
-	.align 5
-pxa_cpu_resume:
-	ldmfd	sp!, {r2, r3}
-#ifndef CONFIG_IWMMXT
-	mar	acc0, r2, r3
-#endif
-	ldmfd	sp!, {r4 - r12, pc}		@ return to caller
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/spitz.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/spitz.c
--- linux-3.0/arch/arm/mach-pxa/spitz.c	2011-06-22 15:07:27.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/spitz.c	2011-10-18 04:06:23.000000000 +0000
@@ -984,6 +984,7 @@ MACHINE_START(SPITZ, "SHARP Spitz")
 	.fixup		= spitz_fixup,
 	.map_io		= pxa27x_map_io,
 	.init_irq	= pxa27x_init_irq,
+	.handle_irq	= pxa27x_handle_irq,
 	.init_machine	= spitz_init,
 	.timer		= &pxa_timer,
 MACHINE_END
@@ -994,6 +995,7 @@ MACHINE_START(BORZOI, "SHARP Borzoi")
 	.fixup		= spitz_fixup,
 	.map_io		= pxa27x_map_io,
 	.init_irq	= pxa27x_init_irq,
+	.handle_irq	= pxa27x_handle_irq,
 	.init_machine	= spitz_init,
 	.timer		= &pxa_timer,
 MACHINE_END
@@ -1004,6 +1006,7 @@ MACHINE_START(AKITA, "SHARP Akita")
 	.fixup		= spitz_fixup,
 	.map_io		= pxa27x_map_io,
 	.init_irq	= pxa27x_init_irq,
+	.handle_irq	= pxa27x_handle_irq,
 	.init_machine	= spitz_init,
 	.timer		= &pxa_timer,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/stargate2.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/stargate2.c
--- linux-3.0/arch/arm/mach-pxa/stargate2.c	2011-06-22 15:07:27.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/stargate2.c	2011-10-18 04:06:23.000000000 +0000
@@ -1001,6 +1001,7 @@ static void __init stargate2_init(void)
 MACHINE_START(INTELMOTE2, "IMOTE 2")
 	.map_io		= pxa27x_map_io,
 	.init_irq	= pxa27x_init_irq,
+	.handle_irq	= pxa27x_handle_irq,
 	.timer		= &pxa_timer,
 	.init_machine	= imote2_init,
 	.boot_params	= 0xA0000100,
@@ -1012,6 +1013,7 @@ MACHINE_START(STARGATE2, "Stargate 2")
 	.map_io = pxa27x_map_io,
 	.nr_irqs = STARGATE_NR_IRQS,
 	.init_irq = pxa27x_init_irq,
+	.handle_irq = pxa27x_handle_irq,
 	.timer = &pxa_timer,
 	.init_machine = stargate2_init,
 	.boot_params = 0xA0000100,
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/tavorevb.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/tavorevb.c
--- linux-3.0/arch/arm/mach-pxa/tavorevb.c	2011-06-22 15:07:27.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/tavorevb.c	2011-10-18 04:06:23.000000000 +0000
@@ -492,6 +492,7 @@ MACHINE_START(TAVOREVB, "PXA930 Evaluati
 	.boot_params    = 0xa0000100,
 	.map_io         = pxa3xx_map_io,
 	.init_irq       = pxa3xx_init_irq,
+	.handle_irq       = pxa3xx_handle_irq,
 	.timer          = &pxa_timer,
 	.init_machine   = tavorevb_init,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/tavorevb3.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/tavorevb3.c
--- linux-3.0/arch/arm/mach-pxa/tavorevb3.c	2011-06-22 15:07:27.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/tavorevb3.c	2011-10-18 04:06:23.000000000 +0000
@@ -129,6 +129,7 @@ MACHINE_START(TAVOREVB3, "PXA950 Evaluat
 	.map_io         = pxa3xx_map_io,
 	.nr_irqs	= TAVOREVB3_NR_IRQS,
 	.init_irq       = pxa3xx_init_irq,
+	.handle_irq       = pxa3xx_handle_irq,
 	.timer          = &pxa_timer,
 	.init_machine   = evb3_init,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/tosa.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/tosa.c
--- linux-3.0/arch/arm/mach-pxa/tosa.c	2011-06-22 15:07:28.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/tosa.c	2011-10-18 04:06:23.000000000 +0000
@@ -974,6 +974,7 @@ MACHINE_START(TOSA, "SHARP Tosa")
 	.map_io         = pxa25x_map_io,
 	.nr_irqs	= TOSA_NR_IRQS,
 	.init_irq       = pxa25x_init_irq,
+	.handle_irq       = pxa25x_handle_irq,
 	.init_machine   = tosa_init,
 	.timer          = &pxa_timer,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/trizeps4.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/trizeps4.c
--- linux-3.0/arch/arm/mach-pxa/trizeps4.c	2011-08-29 03:03:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/trizeps4.c	2011-10-18 04:06:23.000000000 +0000
@@ -558,6 +558,7 @@ MACHINE_START(TRIZEPS4, "Keith und Koep
 	.init_machine	= trizeps4_init,
 	.map_io		= trizeps4_map_io,
 	.init_irq	= pxa27x_init_irq,
+	.handle_irq	= pxa27x_handle_irq,
 	.timer		= &pxa_timer,
 MACHINE_END
 
@@ -567,5 +568,6 @@ MACHINE_START(TRIZEPS4WL, "Keith und Koe
 	.init_machine	= trizeps4_init,
 	.map_io		= trizeps4_map_io,
 	.init_irq	= pxa27x_init_irq,
+	.handle_irq	= pxa27x_handle_irq,
 	.timer		= &pxa_timer,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/viper.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/viper.c
--- linux-3.0/arch/arm/mach-pxa/viper.c	2011-08-29 03:03:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/viper.c	2011-10-18 04:06:23.000000000 +0000
@@ -995,6 +995,7 @@ MACHINE_START(VIPER, "Arcom/Eurotech VIP
 	.boot_params	= 0xa0000100,
 	.map_io		= viper_map_io,
 	.init_irq	= viper_init_irq,
+	.handle_irq	= pxa25x_handle_irq,
 	.timer          = &pxa_timer,
 	.init_machine	= viper_init,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/vpac270.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/vpac270.c
--- linux-3.0/arch/arm/mach-pxa/vpac270.c	2011-08-29 03:03:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/vpac270.c	2011-10-18 04:06:23.000000000 +0000
@@ -719,6 +719,7 @@ MACHINE_START(VPAC270, "Voipac PXA270")
 	.boot_params	= 0xa0000100,
 	.map_io		= pxa27x_map_io,
 	.init_irq	= pxa27x_init_irq,
+	.handle_irq	= pxa27x_handle_irq,
 	.timer		= &pxa_timer,
 	.init_machine	= vpac270_init
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/xcep.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/xcep.c
--- linux-3.0/arch/arm/mach-pxa/xcep.c	2011-06-22 15:07:28.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/xcep.c	2011-10-18 04:06:23.000000000 +0000
@@ -28,8 +28,7 @@
 #include <asm/mach/map.h>
 
 #include <mach/hardware.h>
-#include <mach/pxa2xx-regs.h>
-#include <mach/mfp-pxa25x.h>
+#include <mach/pxa25x.h>
 #include <mach/smemc.h>
 
 #include "generic.h"
@@ -185,6 +184,7 @@ MACHINE_START(XCEP, "Iskratel XCEP")
 	.init_machine	= xcep_init,
 	.map_io		= pxa25x_map_io,
 	.init_irq	= pxa25x_init_irq,
+	.handle_irq	= pxa25x_handle_irq,
 	.timer		= &pxa_timer,
 MACHINE_END
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/z2.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/z2.c
--- linux-3.0/arch/arm/mach-pxa/z2.c	2011-06-22 15:07:28.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/z2.c	2011-10-18 04:06:23.000000000 +0000
@@ -40,6 +40,7 @@
 #include <mach/pxafb.h>
 #include <mach/mmc.h>
 #include <plat/pxa27x_keypad.h>
+#include <mach/pm.h>
 
 #include "generic.h"
 #include "devices.h"
@@ -677,6 +678,20 @@ static void __init z2_pmic_init(void)
 static inline void z2_pmic_init(void) {}
 #endif
 
+#ifdef CONFIG_PM
+static void z2_power_off(void)
+{
+	/* We're using deep sleep as poweroff, so clear PSPR to ensure that
+	 * bootloader will jump to its entry point in resume handler
+	 */
+	PSPR = 0x0;
+	local_irq_disable();
+	pxa27x_cpu_suspend(PWRMODE_DEEPSLEEP, PLAT_PHYS_OFFSET - PAGE_OFFSET);
+}
+#else
+#define z2_power_off   NULL
+#endif
+
 /******************************************************************************
  * Machine init
  ******************************************************************************/
@@ -698,12 +713,15 @@ static void __init z2_init(void)
 	z2_leds_init();
 	z2_keys_init();
 	z2_pmic_init();
+
+	pm_power_off = z2_power_off;
 }
 
 MACHINE_START(ZIPIT2, "Zipit Z2")
 	.boot_params	= 0xa0000100,
 	.map_io		= pxa27x_map_io,
 	.init_irq	= pxa27x_init_irq,
+	.handle_irq	= pxa27x_handle_irq,
 	.timer		= &pxa_timer,
 	.init_machine	= z2_init,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/zeus.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/zeus.c
--- linux-3.0/arch/arm/mach-pxa/zeus.c	2011-06-22 15:07:28.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/zeus.c	2011-10-18 04:06:23.000000000 +0000
@@ -31,17 +31,17 @@
 #include <linux/can/platform/mcp251x.h>
 
 #include <asm/mach-types.h>
+#include <asm/suspend.h>
 #include <asm/mach/arch.h>
 #include <asm/mach/map.h>
 
-#include <mach/pxa2xx-regs.h>
+#include <mach/pxa27x.h>
 #include <mach/regs-uart.h>
 #include <mach/ohci.h>
 #include <mach/mmc.h>
 #include <mach/pxa27x-udc.h>
 #include <mach/udc.h>
 #include <mach/pxafb.h>
-#include <mach/mfp-pxa27x.h>
 #include <mach/pm.h>
 #include <mach/audio.h>
 #include <mach/arcom-pcmcia.h>
@@ -676,7 +676,7 @@ static struct pxa2xx_udc_mach_info zeus_
 static void zeus_power_off(void)
 {
 	local_irq_disable();
-	pxa27x_cpu_suspend(PWRMODE_DEEPSLEEP, PLAT_PHYS_OFFSET - PAGE_OFFSET);
+	cpu_suspend(PWRMODE_DEEPSLEEP, pxa27x_finish_suspend);
 }
 #else
 #define zeus_power_off   NULL
@@ -908,6 +908,7 @@ MACHINE_START(ARCOM_ZEUS, "Arcom/Eurotec
 	.map_io		= zeus_map_io,
 	.nr_irqs	= ZEUS_NR_IRQS,
 	.init_irq	= zeus_init_irq,
+	.handle_irq	= pxa27x_handle_irq,
 	.timer		= &pxa_timer,
 	.init_machine	= zeus_init,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-pxa/zylonite.c torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/zylonite.c
--- linux-3.0/arch/arm/mach-pxa/zylonite.c	2011-06-22 15:07:28.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-pxa/zylonite.c	2011-10-18 04:06:23.000000000 +0000
@@ -24,7 +24,7 @@
 
 #include <asm/mach-types.h>
 #include <asm/mach/arch.h>
-#include <mach/hardware.h>
+#include <mach/pxa3xx.h>
 #include <mach/audio.h>
 #include <mach/pxafb.h>
 #include <mach/zylonite.h>
@@ -426,6 +426,7 @@ MACHINE_START(ZYLONITE, "PXA3xx Platform
 	.map_io		= pxa3xx_map_io,
 	.nr_irqs	= ZYLONITE_NR_IRQS,
 	.init_irq	= pxa3xx_init_irq,
+	.handle_irq	= pxa3xx_handle_irq,
 	.timer		= &pxa_timer,
 	.init_machine	= zylonite_init,
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-realview/Kconfig torvalds-linux-v3.1-rc10/arch/arm/mach-realview/Kconfig
--- linux-3.0/arch/arm/mach-realview/Kconfig	2011-06-22 15:07:28.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-realview/Kconfig	2011-10-18 04:06:23.000000000 +0000
@@ -50,6 +50,7 @@ config MACH_REALVIEW_PB1176
 	bool "Support RealView(R) Platform Baseboard for ARM1176JZF-S"
 	select CPU_V6
 	select ARM_GIC
+	select HAVE_TCM
 	help
 	  Include support for the ARM(R) RealView(R) Platform Baseboard for
 	  ARM1176JZF-S.
diff -NurpP --minimal linux-3.0/arch/arm/mach-realview/include/mach/memory.h torvalds-linux-v3.1-rc10/arch/arm/mach-realview/include/mach/memory.h
--- linux-3.0/arch/arm/mach-realview/include/mach/memory.h	2011-08-29 03:03:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-realview/include/mach/memory.h	2011-10-18 04:06:23.000000000 +0000
@@ -29,10 +29,6 @@
 #define PLAT_PHYS_OFFSET		UL(0x00000000)
 #endif
 
-#ifdef CONFIG_ZONE_DMA
-#define ARM_DMA_ZONE_SIZE	SZ_256M
-#endif
-
 #ifdef CONFIG_SPARSEMEM
 
 /*
diff -NurpP --minimal linux-3.0/arch/arm/mach-realview/include/mach/system.h torvalds-linux-v3.1-rc10/arch/arm/mach-realview/include/mach/system.h
--- linux-3.0/arch/arm/mach-realview/include/mach/system.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-realview/include/mach/system.h	2011-10-18 04:06:23.000000000 +0000
@@ -44,6 +44,7 @@ static inline void arch_reset(char mode,
 	 */
 	if (realview_reset)
 		realview_reset(mode);
+	dsb();
 }
 
 #endif
diff -NurpP --minimal linux-3.0/arch/arm/mach-realview/platsmp.c torvalds-linux-v3.1-rc10/arch/arm/mach-realview/platsmp.c
--- linux-3.0/arch/arm/mach-realview/platsmp.c	2011-08-29 03:03:49.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-realview/platsmp.c	2011-10-18 04:06:23.000000000 +0000
@@ -68,14 +68,6 @@ void __init smp_init_cpus(void)
 
 void __init platform_smp_prepare_cpus(unsigned int max_cpus)
 {
-	int i;
-
-	/*
-	 * Initialise the present map, which describes the set of CPUs
-	 * actually populated at the present time.
-	 */
-	for (i = 0; i < max_cpus; i++)
-		set_cpu_present(i, true);
 
 	scu_enable(scu_base_addr());
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-realview/realview_eb.c torvalds-linux-v3.1-rc10/arch/arm/mach-realview/realview_eb.c
--- linux-3.0/arch/arm/mach-realview/realview_eb.c	2011-06-22 15:07:28.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-realview/realview_eb.c	2011-10-18 04:06:23.000000000 +0000
@@ -470,4 +470,7 @@ MACHINE_START(REALVIEW_EB, "ARM-RealView
 	.init_irq	= gic_init_irq,
 	.timer		= &realview_eb_timer,
 	.init_machine	= realview_eb_init,
+#ifdef CONFIG_ZONE_DMA
+	.dma_zone_size	= SZ_256M,
+#endif
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-realview/realview_pb1176.c torvalds-linux-v3.1-rc10/arch/arm/mach-realview/realview_pb1176.c
--- linux-3.0/arch/arm/mach-realview/realview_pb1176.c	2011-06-22 15:07:28.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-realview/realview_pb1176.c	2011-10-18 04:06:23.000000000 +0000
@@ -365,4 +365,7 @@ MACHINE_START(REALVIEW_PB1176, "ARM-Real
 	.init_irq	= gic_init_irq,
 	.timer		= &realview_pb1176_timer,
 	.init_machine	= realview_pb1176_init,
+#ifdef CONFIG_ZONE_DMA
+	.dma_zone_size	= SZ_256M,
+#endif
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-realview/realview_pb11mp.c torvalds-linux-v3.1-rc10/arch/arm/mach-realview/realview_pb11mp.c
--- linux-3.0/arch/arm/mach-realview/realview_pb11mp.c	2011-06-22 15:07:28.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-realview/realview_pb11mp.c	2011-10-18 04:06:23.000000000 +0000
@@ -367,4 +367,7 @@ MACHINE_START(REALVIEW_PB11MP, "ARM-Real
 	.init_irq	= gic_init_irq,
 	.timer		= &realview_pb11mp_timer,
 	.init_machine	= realview_pb11mp_init,
+#ifdef CONFIG_ZONE_DMA
+	.dma_zone_size	= SZ_256M,
+#endif
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-realview/realview_pba8.c torvalds-linux-v3.1-rc10/arch/arm/mach-realview/realview_pba8.c
--- linux-3.0/arch/arm/mach-realview/realview_pba8.c	2011-06-22 15:07:29.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-realview/realview_pba8.c	2011-10-18 04:06:23.000000000 +0000
@@ -317,4 +317,7 @@ MACHINE_START(REALVIEW_PBA8, "ARM-RealVi
 	.init_irq	= gic_init_irq,
 	.timer		= &realview_pba8_timer,
 	.init_machine	= realview_pba8_init,
+#ifdef CONFIG_ZONE_DMA
+	.dma_zone_size	= SZ_256M,
+#endif
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-realview/realview_pbx.c torvalds-linux-v3.1-rc10/arch/arm/mach-realview/realview_pbx.c
--- linux-3.0/arch/arm/mach-realview/realview_pbx.c	2011-06-22 15:07:29.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-realview/realview_pbx.c	2011-10-18 04:06:23.000000000 +0000
@@ -400,4 +400,7 @@ MACHINE_START(REALVIEW_PBX, "ARM-RealVie
 	.init_irq	= gic_init_irq,
 	.timer		= &realview_pbx_timer,
 	.init_machine	= realview_pbx_init,
+#ifdef CONFIG_ZONE_DMA
+	.dma_zone_size	= SZ_256M,
+#endif
 MACHINE_END
diff -NurpP --minimal linux-3.0/arch/arm/mach-s3c2410/h1940-bluetooth.c torvalds-linux-v3.1-rc10/arch/arm/mach-s3c2410/h1940-bluetooth.c
--- linux-3.0/arch/arm/mach-s3c2410/h1940-bluetooth.c	2011-06-22 15:07:29.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-s3c2410/h1940-bluetooth.c	2011-10-18 04:06:23.000000000 +0000
@@ -18,7 +18,6 @@
 #include <linux/leds.h>
 #include <linux/gpio.h>
 #include <linux/rfkill.h>
-#include <linux/leds.h>
 
 #include <mach/regs-gpio.h>
 #include <mach/hardware.h>
diff -NurpP --minimal linux-3.0/arch/arm/mach-s3c2410/include/mach/gpio-fns.h torvalds-linux-v3.1-rc10/arch/arm/mach-s3c2410/include/mach/gpio-fns.h
--- linux-3.0/arch/arm/mach-s3c2410/include/mach/gpio-fns.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-s3c2410/include/mach/gpio-fns.h	2011-10-18 04:06:23.000000000 +0000
@@ -52,12 +52,6 @@ extern unsigned int s3c2410_gpio_getcfg(
 
 extern int s3c2410_gpio_getirq(unsigned int pin);
 
-#ifdef CONFIG_CPU_S3C2400
-
-extern int s3c2400_gpio_getirq(unsigned int pin);
-
-#endif /* CONFIG_CPU_S3C2400 */
-
 /* s3c2410_gpio_irqfilter
  *
  * set the irq filtering on the given pin
diff -NurpP --minimal linux-3.0/arch/arm/mach-s3c2410/include/mach/pm-core.h torvalds-linux-v3.1-rc10/arch/arm/mach-s3c2410/include/mach/pm-core.h
--- linux-3.0/arch/arm/mach-s3c2410/include/mach/pm-core.h	2011-01-05 00:50:19.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-s3c2410/include/mach/pm-core.h	2011-10-18 04:06:23.000000000 +0000
@@ -62,3 +62,6 @@ static inline void s3c_pm_arch_update_ua
 					   struct pm_uart_save *save)
 {
 }
+
+static inline void s3c_pm_restored_gpios(void) { }
+static inline void s3c_pm_saved_gpios(void) { }
